*******************************************************************
* MouseOver Effect Realization                                    * 
* Author: Gmyria Victor [ berliozz@mail.ru ]                      *
* Special thanks: to someone who apload "onmouseou.zip" to        *
* Universal thread, I've used his code.                           *
* This procedure provides timer support for "MouseOver" effect    *
* Main idea - create class with timer, which will look after      *
* mouse pointer coordinates.                                      *
*******************************************************************

**** Main procedure start
**** Creating new object based on custom class
RELEASE goApp
PUBLIC goApp
goApp=CREATEOBJECT("zzApplication")

**** Launching form
set path to
set default to
DO FORM d:\_MouseOver\Forms\SampleForm

**** Object goApp releases by Form's Unload method
**** Main procedure end


*******************************************************************
*Class definitions                                                *
*******************************************************************
**** Application class
DEFINE CLASS zzApplication AS CUSTOM
    ADD OBJECT tmrTimer AS zzTimer
ENDDEFINE

**** Timer class
DEFINE CLASS zzTimer AS TIMER
    ENABLED=.F.
    INTERVAL=50
    ToCheck=.NULL.

    PROCEDURE TIMER
        oToCheck=SYS(1270)
        IF TYPE('oToCheck')='O'
            IF !ISNULL(THIS.ToCheck) AND THIS.ToCheck.NAME <> oToCheck.NAME
                THIS.ToCheck.OnMouseOut()
                THIS.ToCheck=.NULL.
                THIS.ENABLED = .F.
            ENDIF
        ELSE
            IF !ISNULL(THIS.ToCheck)
                THIS.ToCheck.OnMouseOut()
                THIS.ToCheck=.NULL.
            ENDIF
            THIS.ENABLED = .F.
        ENDIF
    ENDPROC

    PROCEDURE CheckMouseOut
        LPARAMETERS oToCheck

        IF TYPE('oToCheck')='O'
            IF !ISNULL(THIS.ToCheck)
                IF THIS.ToCheck.NAME <> oToCheck.NAME
                    THIS.ToCheck.OnMouseOut()
                ENDIF
            ENDIF
            THIS.ToCheck=oToCheck
            THIS.ENABLED = .T.
        ENDIF
    ENDPROC
ENDDEFI
*******************************************************************
* End of Class definitions                                        *
*******************************************************************
